/*
 * DANG_BEGIN_MODULE
 *
 * This file holds the priv_on/priv_off code
 *
 * DANG_END_MODULE
 *
 * DANG_BEGIN_CHANGELOG
 *
 * $Date: $
 * $Source: $
 * $Revision: $
 * $State: $
 *
 * $Log: $
 *
 * DANG_END_CHANGELOG
 */

#include <unistd.h>

static uid_t euid;
static gid_t egid;
static inited = 0;

int priv_on(void)
{
    if (seteuid(euid) || setegid(egid)) {
	error("MFS: Cannot enable privs!\n");
	return (0);
    }
    return (1);
}

int priv_off(void)
{
    if (!inited) {
	euid = geteuid();
	egid = getegid();
	inited = 1;
    }
    if (seteuid(getuid()) || setegid(getgid())) {
	error("MFS: Cannot disable privs!\n");
	return (0);
    }
    return (1);
}

